const endpointContainer = document.getElementById('endpoint-container');
const getEndpointsBtn = document.getElementById('get-endpoints-btn');

function getEndpoints() {
    let request = new XMLHttpRequest();

    request.addEventListener('load', function(event) {
        let response = JSON.parse(event.target.responseText);
        addBtns(response);
    });

    request.open('GET', 'https://swapi.co/api/');
    request.send();
}

function addBtns(response) {
    const btnHtml = Object.keys(response).reduce(function(html, responseKey) {
        return (
            html +
            '<button data-url="' +
            response[responseKey] +
            '">' +
            responseKey +
            '</button>'
        );
    }, '');

    endpointContainer.innerHTML = btnHtml;
}

function makeRequest(event) {
    if (event.target.matches('button')) {
        let btn = event.target;
        let btnText = btn.innerHTML;
        btn.innerHTML = 'loading...';

        let request = new XMLHttpRequest();

        request.addEventListener('load', function(event) {
            if (event.target.status === 200) {
                let response = JSON.parse(event.target.responseText);
                console.log(response);
                btn.innerHTML = btnText;
            } else {
                console.log(event.target);
                btn.innerHTML = 'Dikke fail...';
            }
        });

        request.open('GET', event.target.dataset.url);
        request.send();
    }
}

getEndpointsBtn.addEventListener('click', getEndpoints);
endpointContainer.addEventListener('click', makeRequest);
