const questions = [
    {
        question: 'Linus Torvalds created Linux and Git.',
        correctAnswer: 'True',
    },
    {
        question:
            'The programming language "Python" is based off a modified version of "JavaScript".',
        correctAnswer: 'False',
    },
    {
        question: 'The logo for Snapchat is a Bell.',
        correctAnswer: 'False',
    },
    {
        question: 'RAM stands for Random Access Memory.',
        correctAnswer: 'True',
    },
    {
        question: '"HTML" stands for Hypertext Markup Language.',
        correctAnswer: 'True',
    },
    {
        question:
            'In most programming languages, the operator ++ is equivalent to the statement "+= 1".',
        correctAnswer: 'True',
    },
    {
        question: 'The Windows 7 operating system has six main editions.',
        correctAnswer: 'True',
    },
    {
        question:
            'The Windows ME operating system was released in the year 2000.',
        correctAnswer: 'True',
    },
    {
        question:
            'The NVidia GTX 1080 gets its name because it can only render at a 1920x1080 screen resolution.',
        correctAnswer: 'False',
    },
    {
        question: 'Linux was first created as an alternative to Windows XP.',
        correctAnswer: 'False',
    },
];

let shuffledQuestions;

const $questionsContainer = document.getElementById('result-container');
const $correctAnswerCount = document.getElementById('total-correct');
const $questionContainer = document.getElementById('question');
const $btnContainer = document.getElementById('answer-container');

function shuffleQuestions(questions) {
    let tempQuestions = questions.slice();
    let shuffledQuestions = [];
    while (tempQuestions.length > 0) {
        let index = Math.floor(Math.random * tempQuestions.length);
        shuffledQuestions.push(tempQuestions.splice(index, 1)[0]);
    }
    return shuffledQuestions;
}

function renderQuestion(currentIndex) {
    if (currentIndex === 10) {
        const score = $correctAnswerCount.innerText;
        $questionContainer.innerHTML = `Your score is ${score}, play again?`;
    } else {
        $questionContainer.innerHTML = shuffledQuestions[currentIndex].question;
    }
    $questionContainer.dataset.index = currentIndex;
}

function renderCorrectCount(reset) {
    if (reset) {
        $correctAnswerCount.innerText = 0;
    } else {
        $correctAnswerCount.innerText =
            parseInt($correctAnswerCount.innerText) + 1;
    }
}

function renderQuestionState($currentQuestion, state) {
    switch (state) {
        case 'success':
            $currentQuestion.classList.add('is-success');
            break;
        case 'danger':
            $currentQuestion.classList.add('is-danger');
            break;
        default:
            $currentQuestion.classList.remove('is-success', 'is-danger');
    }
}

function answerClicked(event) {
    if (event.target.matches('.answer')) {
        const currentIndex = parseInt($questionContainer.dataset.index);
        const selectedAnswer = event.target.matches('#answer-true');
        const $currentQuestion = $questionsContainer.children[currentIndex];

        if (currentIndex === 10) {
            if (selectedAnswer) {
                init();
            }
            return;
        }

        if (
            (shuffledQuestions[currentIndex].correctAnswer === 'True') ===
            selectedAnswer
        ) {
            renderQuestionState($currentQuestion, 'success');
            renderCorrectCount();
        } else {
            renderQuestionState($currentQuestion, 'danger');
        }

        renderQuestion(currentIndex + 1);
    }
}

function init() {
    shuffledQuestions = shuffleQuestions(questions);

    Array.from($questionsContainer.children).forEach(function($question) {
        renderQuestionState($question);
    });

    renderQuestion(0);
    renderCorrectCount(true);
}

init();
$btnContainer.addEventListener('click', answerClicked);
